//+------------------------------------------------------------------+
//|                                                  VininE Game.mq4 |
//|                      Copyright  2008, Victor Nicolaev aka Vinin |
//|                                           skype: victor.nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+

//   ""  
//    ,     , ,   


#property copyright "Copyright  2008 Victor Nicolaev"
#property link      "vinin@mail.ru"


extern double Lots = 0.1;        //    
extern double MaximumRisk=5.0;   //  
extern int TP=200;               //
extern int SL=200;               //
extern int MagicNumber = 0;      //      

int Order_Count[6];
string   NameOP[]={"BUY","SELL","BUYLIMMIT","SELLLIMIT","BUYSTOP","SELLSTOP"};
#include <stdlib.mqh>
#include <WinUser32.mqh>

bool bstart;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()  {
   bstart=false;
   return(0);
}
int deinit() {return(0);}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   static int prevtime=0;
   if(Time[0] == prevtime)  return(0);
   prevtime = Time[0];
   
   Order_Close(Symbol(), MagicNumber);
   int cmd=Signal();
   double _cmd=iif(cmd==OP_BUY,1,-1);
   double Price=iif(cmd==OP_BUY,Ask,Bid);
   double _TP=iif(TP>0,iif(cmd==OP_BUY,Bid,Ask)+_cmd*TP*Point,0);
   double _SL=iif(SL>0,iif(cmd==OP_BUY,Bid,Ask)-_cmd*SL*Point,0);
   color OpenCl=iif(_cmd>0,Blue,Red);
   
   Order_Open(Symbol(), cmd, Price, _TP, _SL,MagicNumber, OpenCl);
   return(0);
}

int Order_Open(string _Symbol, int OP_CMD, double Price, double _TP, double _SL, int Magic, color Opencl){
   return(OrderSend(_Symbol, OP_CMD, getLots(), Price, 3, _SL, _TP, "", Magic, 0, Opencl));
}


int Signal(){
   int total=OrdersHistoryTotal();
   int cmd=-1;
   for (int i=total-1;i>=0;i--) {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
      if (OrderSymbol()!=Symbol())                    continue;
      if (OrderMagicNumber()!=MagicNumber )           continue;
      if (OrderProfit()>0) cmd=OrderType(); else cmd=MathAbs(OrderType()-1);
      break;
   }
   if (cmd==-1) {
      if (Close[1]>Open[i]) cmd=OP_BUY; else cmd=OP_SELL;
   }
   return(cmd);
}

double iif(bool a, double b, double c){if(a) return(b);return(c);}

double getLots() {
   if (MaximumRisk>0) {
      double minlot=MarketInfo(Symbol(),MODE_MINLOT);
      double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);       
      double step=MarketInfo(Symbol(),MODE_LOTSTEP);

      double lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 100000.0/step, 0)*step; 
      lot=MathMax(MathMin(lot,maxlot),minlot);
      
   }
   else lot=Lots;
   return(lot); 
}

void Order_Close(string symbol, int Magic, int OP=-1){
   bool res;
   GetLastError();
   for(int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))   continue;
      if (OrderSymbol() != symbol)                       continue;
      if (OrderMagicNumber() != Magic)                   continue;
      if (OrderType()!=OP && OP!=-1)                     continue;
      
      RefreshRates();
      
      res=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 3);
      if (!res) {
         int err=GetLastError();
         Print("Error(",err,") delete order ",NameOP[OP],": ",ErrorDescription(err));
      }
   }
}

//===============================================================================
//          
//===============================================================================
int Order_Count_Calculate(string symbol, int Magic, int OP=-1){
   ArrayInitialize(Order_Count,0);
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))   continue;
      if (OrderSymbol() != symbol)                     continue;
      if (OrderMagicNumber() != Magic)                   continue;
      if (OrderType()!=OP && OP!=-1)                     continue;
      Order_Count[OrderType()]++;
   }
   if (OP!=-1) return(Order_Count[OP]);
}

//===============================================================================
//         
//
//===============================================================================
double GetLots() {
   double LotMin=MarketInfo(Symbol(),MODE_MINLOT);
   double LotMax=MarketInfo(Symbol(),MODE_MAXLOT);
   double LotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot=MathRound(Lots/LotStep)*LotStep;
   
   
   
   lot=MathMax(LotMin,MathMin(LotMax,lot));
   
   return(lot); 
}